"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _api = require("@storybook/api");

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

var _SyntaxHighlighter = _interopRequireDefault(require("./SyntaxHighlighter"));

var _githubGist = _interopRequireDefault(require("react-syntax-highlighter/dist/esm/styles/hljs/github-gist"));

var _shared = require("./shared");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledSyntaxHighlighter = (0, _theming.styled)(_SyntaxHighlighter["default"])(function (_ref) {
  var theme = _ref.theme;
  return {
    fontSize: theme.typography.size.s2 - 1
  };
});

var fileMatcher = function fileMatcher(_ref2) {
  var lang = _ref2.lang,
      matchFile = _ref2.matchFile;

  if (!matchFile) {
    return function (str) {
      return str.endsWith(".".concat(lang));
    };
  } else if (typeof matchFile === 'function') {
    return matchFile;
  } else if (typeof matchFile === 'string') {
    return function (str) {
      return str.endsWith(".".concat(matchFile));
    };
  } else if (matchFile instanceof RegExp) {
    return function (str) {
      return matchFile.test(str);
    };
  }
};

var mapper = function mapper(_ref3) {
  var lang = _ref3.lang,
      matchFile = _ref3.matchFile;
  return function (_ref4) {
    var state = _ref4.state,
        api = _ref4.api;
    matchFile = fileMatcher({
      lang: lang,
      matchFile: matchFile
    });
    var story = state.storiesHash[state.storyId];
    var paramValue = story && api.getParameters(story.id, _shared.PARAM_KEY);

    if (!paramValue) {
      return {
        sourceFiles: []
      };
    }

    var sourceFiles = paramValue.sourceFiles.filter(function (_ref5) {
      var path = _ref5.path;
      return matchFile(path);
    });
    return {
      sourceFiles: sourceFiles
    };
  };
};

var CodePanel = function CodePanel(_ref6) {
  var active = _ref6.active,
      lang = _ref6.lang,
      label = _ref6.label,
      matchFile = _ref6.matchFile;

  if (!active) {
    return null;
  }

  return _react["default"].createElement(_api.Consumer, {
    filter: mapper({
      lang: lang,
      matchFile: matchFile
    })
  }, function (_ref7) {
    var sourceFiles = _ref7.sourceFiles;
    return sourceFiles.length ? _react["default"].createElement(StyledSyntaxHighlighter, {
      language: lang || 'plaintext',
      showLineNumbers: "true",
      copyable: true,
      padded: true,
      style: _githubGist["default"]
    }, sourceFiles.map(function (_ref8) {
      var code = _ref8.code;
      return code;
    }).join('\n\n')) : // <Panel className="addon-code-container">
    // </Panel>
    _react["default"].createElement(_components.Placeholder, null, _react["default"].createElement(_react.Fragment, null, "No ", label, " code"));
  });
};

var _default = CodePanel;
exports["default"] = _default;